<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFreeBaggageAllowanceTypes ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfFreeBaggageAllowanceTypes extends AbstractStructArrayBase
{
    /**
     * The FreeBaggageAllowanceTypes
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgFreeBaggageAllowanceTypes[]
     */
    public $FreeBaggageAllowanceTypes;
    /**
     * Constructor method for ArrayOfFreeBaggageAllowanceTypes
     * @uses DgArrayOfFreeBaggageAllowanceTypes::setFreeBaggageAllowanceTypes()
     * @param \dgsoft\StructType\DgFreeBaggageAllowanceTypes[] $freeBaggageAllowanceTypes
     */
    public function __construct(array $freeBaggageAllowanceTypes = array())
    {
        $this
            ->setFreeBaggageAllowanceTypes($freeBaggageAllowanceTypes);
    }
    /**
     * Get FreeBaggageAllowanceTypes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgFreeBaggageAllowanceTypes[]|null
     */
    public function getFreeBaggageAllowanceTypes()
    {
        return isset($this->FreeBaggageAllowanceTypes) ? $this->FreeBaggageAllowanceTypes : null;
    }
    /**
     * Set FreeBaggageAllowanceTypes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgFreeBaggageAllowanceTypes[] $freeBaggageAllowanceTypes
     * @return \dgsoft\ArrayType\DgArrayOfFreeBaggageAllowanceTypes
     */
    public function setFreeBaggageAllowanceTypes(array $freeBaggageAllowanceTypes = array())
    {
        foreach ($freeBaggageAllowanceTypes as $arrayOfFreeBaggageAllowanceTypesFreeBaggageAllowanceTypesItem) {
            // validation for constraint: itemType
            if (!$arrayOfFreeBaggageAllowanceTypesFreeBaggageAllowanceTypesItem instanceof \dgsoft\StructType\DgFreeBaggageAllowanceTypes) {
                throw new \InvalidArgumentException(sprintf('The FreeBaggageAllowanceTypes property can only contain items of \dgsoft\StructType\DgFreeBaggageAllowanceTypes, "%s" given', is_object($arrayOfFreeBaggageAllowanceTypesFreeBaggageAllowanceTypesItem) ? get_class($arrayOfFreeBaggageAllowanceTypesFreeBaggageAllowanceTypesItem) : gettype($arrayOfFreeBaggageAllowanceTypesFreeBaggageAllowanceTypesItem)), __LINE__);
            }
        }
        if (is_null($freeBaggageAllowanceTypes) || (is_array($freeBaggageAllowanceTypes) && empty($freeBaggageAllowanceTypes))) {
            unset($this->FreeBaggageAllowanceTypes);
        } else {
            $this->FreeBaggageAllowanceTypes = $freeBaggageAllowanceTypes;
        }
        return $this;
    }
    /**
     * Add item to FreeBaggageAllowanceTypes value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgFreeBaggageAllowanceTypes $item
     * @return \dgsoft\ArrayType\DgArrayOfFreeBaggageAllowanceTypes
     */
    public function addToFreeBaggageAllowanceTypes(\dgsoft\StructType\DgFreeBaggageAllowanceTypes $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgFreeBaggageAllowanceTypes) {
            throw new \InvalidArgumentException(sprintf('The FreeBaggageAllowanceTypes property can only contain items of \dgsoft\StructType\DgFreeBaggageAllowanceTypes, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FreeBaggageAllowanceTypes[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgFreeBaggageAllowanceTypes|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgFreeBaggageAllowanceTypes|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgFreeBaggageAllowanceTypes|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgFreeBaggageAllowanceTypes|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgFreeBaggageAllowanceTypes|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FreeBaggageAllowanceTypes
     */
    public function getAttributeName()
    {
        return 'FreeBaggageAllowanceTypes';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfFreeBaggageAllowanceTypes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
